"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _moment = _interopRequireDefault(require("moment"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var VTodoGenerator = /*#__PURE__*/function () {
  function VTodoGenerator(todoObject) {
    _classCallCheck(this, VTodoGenerator);
    if (todoObject != null && Object.keys(todoObject).length > 0) {
      for (var key in todoObject) {
        this[key] = todoObject[key];
      }
    } else {
      throw new Error("No valid task object provided.");
    }
    this.oldData = null;
  }
  _createClass(VTodoGenerator, [{
    key: "varNotEmpty",
    value: function varNotEmpty(variable) {
      if (variable != null && variable != undefined) {
        return true;
      } else {
        return false;
      }
    }
  }, {
    key: "generate",
    value: function generate() {
      var skipVCALENDAR = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var dtstamp = "";
      if (this.dtstamp != null && this.dtstamp != "") {
        dtstamp = this.getISO8601Date(this.dtstamp);
      } else {
        dtstamp = this.getISO8601Date((0, _moment["default"])().unix() * 1000);
      }
      var categories = "";
      var uid = "";
      if (this.uid != null && this.uid != "") {
        uid = this.uid;
      } else {
        uid = this.generateNewUID();
      }
      if (this.categories != null && Array.isArray(this.categories) && this.categories.length > 0) {
        for (var i in this.categories) {
          if (i != this.categories.length - 1) {
            categories += this.categories[i] + ",";
          } else {
            categories += this.categories[i];
          }
        }
      }
      var finalVTODO = "";
      if (skipVCALENDAR == null || skipVCALENDAR == undefined || skipVCALENDAR == false) {
        finalVTODO += "BEGIN:VCALENDAR\nVERSION:2.0\nPRODID:-//VTODOGENERATOR v1.0.0\n";
      }
      finalVTODO += "BEGIN:VTODO\nUID:" + uid + "\n";
      finalVTODO += "DTSTAMP:" + dtstamp + "\n";
      if (this.created != null && this.created != "") {
        finalVTODO += "CREATED:" + this.getISO8601Date(this.created) + "\n";
      }
      if (this.summary != null && this.summary != "") {
        finalVTODO += "SUMMARY:" + this.summary + "\n";
      }
      if (this.due != null && this.due != "") {
        finalVTODO += "DUE:" + this.getISO8601Date(this.due) + "\n";
      }
      if (this.completed != null && this.completed != "") {
        finalVTODO += "COMPLETED:" + this.getISO8601Date((0, _moment["default"])().unix() * 1000) + "\n";

        // The task is completed, so we set the STATUS as COMPLETED.
        // This is required for apps like JTX Boards to recognize that the task has been completed.
        finalVTODO += "STATUS:COMPLETED\n";

        //finalVTODO +="PERCENT-COMPLETE: 100\n" 
        if (this.completion != null && this.completion != "") {
          finalVTODO += "PERCENT-COMPLETE:" + this.completion + "\n";
        }
      } else {
        if (this.status != null && this.status != "" && this.statusIsValid(this.status)) {
          finalVTODO += "STATUS:" + this.status + "\n";
        }
        if (this.completion != null && this.completion != "") {
          finalVTODO += "PERCENT-COMPLETE:" + this.completion + "\n";
        } else {
          finalVTODO += "PERCENT-COMPLETE:0\n";
        }
      }
      if (categories != null && categories != "") {
        finalVTODO += "CATEGORIES:" + categories + "\n";
      }
      if (this.relatedto != null && this.relatedto != "") {
        if (typeof this.relatedto == "string") {
          finalVTODO += "RELATED-TO:" + this.relatedto + "\n";
        } else {
          if (Array.isArray(this.relatedto)) {
            for (var _i in this.relatedto) {
              if (this.varNotEmpty(this.relatedto[_i].params) && this.varNotEmpty(this.relatedto[_i].params.RELTYPE) && this.varNotEmpty(this.relatedto[_i].val)) {
                var relatedOutput = "RELATED-TO;RELTYPE=" + this.relatedto[_i].params.RELTYPE.toString().toUpperCase() + ":" + this.relatedto[_i].val + "\n";
                finalVTODO += relatedOutput;
              }
            }
          } else {
            var relatedOutput = "RELATED-TO;RELTYPE=" + this.relatedto.params.RELTYPE.toString().toUpperCase() + ":" + this.relatedto.val + "\n";
            finalVTODO += relatedOutput;
          }
        }
      }
      if (this.priority != null && this.priority != "") {
        finalVTODO += "PRIORITY:" + this.priority + "\n";
      }
      if (this.description != null && this.description != "") {
        var description = this.description.replace(/(?:\r\n|\r|\n)/g, '\\n');
        finalVTODO += "DESCRIPTION:" + description + "\n";
      }
      if (this.start != null && this.start != "") {
        finalVTODO += "DTSTART:" + this.getISO8601Date(this.start) + "\n";
      }
      if (this["class"] != null && this["class"] != "" && this["class"] != undefined) {
        finalVTODO += "CLASS:" + this["class"] + "\n";
      }
      if (this.geo != null && this.geo != "" && this.geo != undefined) {
        finalVTODO += "GEO:" + this.geo + "\n";
      }

      /*
      if(this.lastmod!=null && this.lastmod!="" && this.lastmod!=undefined)
      {
          finalVTODO +="LAST-MODIFIED:"+this.lastmod+"\n"
       }else{
          finalVTODO +="LAST-MODIFIED:"+dtstamp+"\n"
       }
      */
      finalVTODO += "LAST-MODIFIED:" + this.getISO8601Date(Date.now()) + "\n";
      if (this.location != null && this.location != "" && this.location != undefined) {
        finalVTODO += "LOCATION:" + this.location + "\n";
      }
      if (this.organizer != null && this.organizer != "" && this.organizer != undefined) {
        finalVTODO += "ORGANIZER:" + this.organizer + "\n";
      }
      if (this.sequence != null && this.sequence != "" && this.sequence != undefined) {
        finalVTODO += "SEQUENCE:" + parseInt(this.sequence) + 1 + "\n";
      }
      if (this.resources != null && this.resources != "" && Array.isArray(this.resources) && this.resources.length > 0) {
        var resourcesOutput = "RESOURCES:";
        for (var _i2 in this.resources) {
          if (_i2 != 0) {
            resourcesOutput += ",";
          }
          resourcesOutput += this.resources[_i2];
        }
        finalVTODO += resourcesOutput + "\n";
      }
      if (this.rrule != null && this.rrule != "" && this.rrule["FREQ"] != "" && this.rrule["FREQ"] != null && this.rrule["INTERVAL"] != "" && this.rrule.INTERVAL != "") {
        var rruleOutput = "RRULE:FREQ=" + this.rrule.FREQ + ";INTERVAL=" + this.rrule.INTERVAL + ";";
        if (this.rrule.COUNT != null && this.rrule.COUNT != "") {
          rruleOutput += "COUNT=" + this.rrule.COUNT + ";";
        }
        if (this.rrule.UNTIL != "" && this.rrule.UNTIL != null) {
          rruleOutput += "UNTIL=" + this.getISO8601Date(this.rrule.UNTIL, true) + ";";
        }
        finalVTODO += rruleOutput + "\n";
      }

      /*
       // Adding attendee info as of now breaks calendar (not the todo, but the entire calendar in Nextcloud client for some reason.)
      // Another reason for skipping is that RFC5545 mentions that attendee must not be included in a todo, but rather in a group calendar object (Section 3.8.4.1).
        if(this.attendee!="" && this.attendee!=null && Array.isArray(this.attendee))
      {
          var attendeeOutput ="ATTENDEE"
          
          for (const i in this.attendee)
          {
              if(i.toUpperCase()!="ROLE")
              {
                  attendeeOutput+=i.toString().toUpperCase()+"="+this.attendee[i]+";"
               }
          }
           finalVTODO +=attendeeOutput+":\n"
       }
      */
      if (this.url != "" && this.url != null) {
        finalVTODO += "URL:" + this.url + "\n";
      }
      if (this.recurrenceid != "" && this.recurrenceid != null) {
        finalVTODO += "RECURRENCE-ID:" + this.getISO8601Date(this.recurrenceid) + "\n";
      }
      finalVTODO += "END:VTODO\n";
      if (this.recurrences != null) {
        for (var _i3 in this.recurrences) {
          //console.log(this.recurrences[i])
          var newVTODO = new VTodoGenerator(this.recurrences[_i3]);
          finalVTODO += newVTODO.generate(true);
        }
      }
      if (skipVCALENDAR == null || skipVCALENDAR == undefined || skipVCALENDAR == false) {
        finalVTODO += "END:VCALENDAR\n";
      }
      return finalVTODO;
    }
  }, {
    key: "getISO8601Date",
    value: function getISO8601Date(date, skipTime) {
      var toReturn = "";
      if (date != null) {
        var dueDateUnix = (0, _moment["default"])(date).unix() * 1000;
        toReturn = (0, _moment["default"])(dueDateUnix).format('YYYYMMDD');
        if (skipTime == null || skipTime != "null" && skipTime == false) {
          toReturn += "T" + (0, _moment["default"])(dueDateUnix).format('HHmmss');
        }
      } else {
        return null;
      }
      return toReturn;
    }
  }, {
    key: "generateNewUID",
    value: function generateNewUID() {
      var crypto = require("crypto");
      var id = crypto.randomBytes(32).toString('hex');
      return id + "@intri";
    }
  }, {
    key: "statusIsValid",
    value: function statusIsValid(status) {
      var validStatuses = this.constructor.getValidStatusValues();
      var found = false;
      for (var i = 0; i < validStatuses.length; i++) {
        if (validStatuses[i] == status) {
          return true;
        }
      }
      return found;
    }
  }, {
    key: "setOldData",
    value: function setOldData(oldData) {
      this.oldData = oldData;
    }
  }], [{
    key: "getValidStatusValues",
    value: function getValidStatusValues() {
      var validvalues = ["NEEDS-ACTION", "COMPLETED", "IN-PROCESS", "CANCELLED"];
      return validvalues;
    }
  }]);
  return VTodoGenerator;
}();
var _default = VTodoGenerator;
exports["default"] = _default;